/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Webflow from "../index";
/**
 * A comment thread represents a conversation between users on a specific page. Each comment thread has a unique identifier and can contain multiple comments. Retrieve comment replies using the replies API endpoint.
 */
export interface CommentThread {
    /** Unique identifier for the comment thread */
    id: string;
    /** The site unique identifier */
    siteId: string;
    /** The page unique identifier */
    pageId: string;
    /** The locale unique identifier */
    localeId?: string;
    /** The item unique identifier */
    itemId?: string;
    /** The breakpoint the comment was left on */
    breakpoint: string;
    /** The URL of the page the comment was left on */
    url: string;
    /** The content of the comment reply */
    content: string;
    /** Boolean determining if the comment thread is resolved */
    isResolved: boolean;
    author: Webflow.CommentThreadAuthor;
    /** List of mentioned users. This is an empty array until email notifications are sent, which can take up to 5 minutes after the comment is created. */
    mentionedUsers: Webflow.CommentThreadMentionedUsersItem[];
    /** The date the item was created */
    createdOn: string;
    /** The date the item was last updated */
    lastUpdated: string;
}
