/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Webflow from "../index";
/**
 * The Page object
 */
export interface Page {
    /** Unique identifier for the Page */
    id: string;
    /** Unique identifier for the Site */
    siteId?: string;
    /** Title of the Page */
    title?: string;
    /** slug of the Page (derived from title) */
    slug?: string;
    /** Identifier of the parent folder */
    parentId?: string;
    /** Unique identifier for a linked Collection, value will be null if the Page is not part of a Collection. */
    collectionId?: string;
    /** The date the Page was created */
    createdOn?: Date;
    /** The date the Page was most recently updated */
    lastUpdated?: Date;
    /** Whether the Page has been archived */
    archived?: boolean;
    /** Whether the Page is a draft */
    draft?: boolean;
    /** Indicates whether the Page supports [Page Branching](https://university.webflow.com/lesson/page-branching) */
    canBranch?: boolean;
    /** Indicates whether the Page is a Branch of another Page [Page Branching](https://university.webflow.com/lesson/page-branching) */
    isBranch?: boolean;
    /** Indicates whether the Page is restricted by [Memberships Controls](https://university.webflow.com/lesson/webflow-memberships-overview#how-to-manage-page-restrictions) */
    isMembersOnly?: boolean;
    /** SEO-related fields for the Page */
    seo?: Webflow.PageSeo;
    /** Open Graph fields for the Page */
    openGraph?: Webflow.PageOpenGraph;
    /** Unique ID of the page locale */
    localeId?: string;
    /** Relative path of the published page URL */
    publishedPath?: string;
}
