/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Webflow from "../index";
/**
 * Contains content-specific details for a product, covering both standard (e.g., title, description)  and custom fields tailored to the product setup.
 */
export interface ProductFieldData {
    /** Name of the Product */
    name?: string;
    /** URL structure of the Product in your site. */
    slug?: string;
    /** A description of your product */
    description?: string;
    /** Boolean determining if the Product is shippable */
    shippable?: boolean;
    /** Variant types to include in SKUs */
    skuProperties?: Webflow.SkuPropertyList[];
    /** The categories your product belongs to. */
    categories?: string[];
    /** Product tax class */
    taxCategory?: Webflow.ProductFieldDataTaxCategory;
    /** The default SKU associated with this product. */
    defaultSku?: string;
    /** <a href="https://university.webflow.com/lesson/add-and-manage-products-and-categories?topics=ecommerce#how-to-understand-product-types">Product types.</a> Enums reflect the following values in order: Physical, Digital, Service, Advanced" */
    ecProductType?: Webflow.ProductFieldDataEcProductType;
}
