/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Webflow from "../index";
/**
 * Standard and Custom fields for a SKU
 */
export interface SkuFieldData {
    skuValues?: Webflow.SkuValueList;
    /** Name of the Product */
    name: string;
    /** URL structure of the Product in your site. */
    slug: string;
    /** price of SKU */
    price: Webflow.SkuFieldDataPrice;
    /** comparison price of SKU */
    compareAtPrice?: Webflow.SkuFieldDataCompareAtPrice;
    /** [Billing method](https://help.webflow.com/hc/en-us/articles/33961432087955-Add-and-manage-products-and-categories#billing-methods)for the SKU */
    ecSkuBillingMethod?: Webflow.SkuFieldDataEcSkuBillingMethod;
    /** [Subscription plan](https://help.webflow.com/hc/en-us/articles/33961432087955-Add-and-manage-products-and-categories#subscription) for the SKU */
    ecSkuSubscriptionPlan?: Webflow.SkuFieldDataEcSkuSubscriptionPlan;
    /** A boolean indicating whether inventory for this product should be tracked. */
    trackInventory?: boolean;
    /** Quantity of SKU that will be tracked as items are ordered. */
    quantity?: number;
    /** The URL for the main image of the SKU */
    mainImage?: string;
    /** A unique identifier for the SKU */
    sku?: string;
    /** The properties of the SKU */
    skuProperties?: Webflow.SkuPropertyList[];
}
