/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as environments from "../../../../../../environments";
import * as core from "../../../../../../core";
import * as Webflow from "../../../../../index";
export declare namespace ActivityLogs {
    interface Options {
        environment?: core.Supplier<environments.WebflowEnvironment | environments.WebflowEnvironmentUrls>;
        accessToken: core.Supplier<core.BearerToken>;
    }
    interface RequestOptions {
        /** The maximum time to wait for a response in seconds. */
        timeoutInSeconds?: number;
        /** The number of times to retry the request. Defaults to 2. */
        maxRetries?: number;
        /** A hook to abort the request. */
        abortSignal?: AbortSignal;
        /** Additional headers to include in the request. */
        headers?: Record<string, string>;
    }
}
export declare class ActivityLogs {
    protected readonly _options: ActivityLogs.Options;
    constructor(_options: ActivityLogs.Options);
    /**
     * Retrieve Activity Logs for a specific Site.
     *
     * <Warning title="Enterprise Only">This endpoint requires an Enterprise workspace.</Warning>
     *
     * Required scope: `site_activity:read`
     *
     * @param {string} siteId - Unique identifier for a Site
     * @param {Webflow.sites.ActivityLogsListRequest} request
     * @param {ActivityLogs.RequestOptions} requestOptions - Request-specific configuration.
     *
     * @throws {@link Webflow.ForbiddenError}
     * @throws {@link Webflow.NotFoundError}
     * @throws {@link Webflow.TooManyRequestsError}
     * @throws {@link Webflow.InternalServerError}
     *
     * @example
     *     await client.sites.activityLogs.list("580e63e98c9a982ac9b8b741")
     */
    list(siteId: string, request?: Webflow.sites.ActivityLogsListRequest, requestOptions?: ActivityLogs.RequestOptions): Promise<Webflow.SiteActivityLogResponse>;
    protected _getAuthorizationHeader(): Promise<string>;
}
