/**
 * This file was auto-generated by Fern from our API Definition.
 */
import * as Webflow from "../index";
/**
 * A comment thread represents a conversation between users on a specific page. Each comment thread has a unique identifier and can contain multiple comments.
 */
export interface CommentReply {
    /** Unique identifier for the comment thread */
    id: string;
    /** The comment reply unique identifier */
    commentId: string;
    /** The site unique identifier */
    siteId: string;
    /** The page unique identifier */
    pageId: string;
    /** The locale unique identifier */
    localeId?: string;
    /** The breakpoint the comment was left on */
    breakpoint: string;
    /** The content of the comment reply */
    content: string;
    /** Boolean determining if the comment thread is resolved */
    isResolved: boolean;
    author: Webflow.CommentReplyAuthor;
    /** List of mentioned users is an empty array until email notifications are sent. */
    mentionedUsers?: Webflow.CommentReplyMentionedUsersItem[];
    /** The date the item was last updated */
    lastUpdated: string;
    /** The date the item was created */
    createdOn: string;
}
